include "Vram.inc"

ext VVram_

VramTop equ Vram

dseg
Backup: defs WindowWidth*WindowHeight

; void WaitVBlank();
cseg
WaitVBlank_: public WaitVBlank_
    ex af,af'
        do 
            ld a,(0e002h)
            and 80h
        while nz | wend
    ex af,af'
ret


; void ClearScreen();
cseg
Fill0:
    do
        ld (hl),0
        inc hl
        dec bc
        ld a,c
        or b
    while nz | wend
ret
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld bc,VramWidth*VramHeight
        call Fill0

        ld hl,Backup
        ld bc,WindowWidth*WindowHeight
        call Fill0
    pop bc | pop hl | pop af
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,VramTop
        exx
            ld hl,Backup
        exx
        ld c, WindowHeight ; vertical count    
        do
            ld b,WindowWidth
            do 
                ld a,(de) | inc de
                exx
                    cp (hl)
                exx
                if nz
                    exx
                        ld (hl),a
                    exx
                    call WaitVBlank_
                    ld (hl),a
                endif
                exx
                    inc hl
                exx
                inc hl
            dwnz
            push bc
                ld bc,VramRowSize-WindowWidth
                add hl,bc
            pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb 0,61h,62h,63h,64h,65h,66h,67h,68h,69h,6bh,6ah,2fh,2ah,2eh,2dh
    defb 20h,21h,22h,23h,24h,25h,26h,27h,28h,29h,4fh,2ch,51h,2bh,57h,49h
    defb 55h,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
    defb 16,17,18,19,20,21,22,23,24,25,26,52h,59h,54h,46h,3ch
PrintC_: public PrintC_
    push af
        ld a,e
        exx
            ld l,a
            ld h,0
            ld de,CharTable - ' '
            add hl,de
            ld a,(hl)
        exx
        ld (hl),a
        inc hl
    pop af
ret
